﻿Imports Infragistics.Win.UltraWinTree

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim childSet As UltraTreeColumnSet = tvOrders.ColumnSettings.ColumnSets("details")
        For i As Integer = 1 To 50
            Dim node As UltraTreeNode = Me.tvOrders.Nodes.Add
            node.Tag = New Object
            For z As Integer = 1 To 3
                Dim node2 As UltraTreeNode = node.Nodes.Add
                node2.Override.ColumnSet = childSet
            Next
        Next

    End Sub

    Dim prevNode As UltraTreeNode = Nothing
    Private Sub tvOrders_AfterSelect(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinTree.SelectEventArgs) Handles tvOrders.AfterSelect
        Try

            If e.NewSelections.Count > 0 Then
                If e.NewSelections(0).Tag IsNot Nothing Then

                    'make sure stupid tree refreshed and actually sees new selected nodes
                    tvOrders.Refresh()
                    Application.DoEvents()
                    If prevNode IsNot Nothing AndAlso prevNode IsNot e.NewSelections(0) Then
                        prevNode.Expanded = False
                    End If

                    e.NewSelections(0).Expanded = True
                    If e.NewSelections(0).Nodes.Count > 0 Then
                        e.NewSelections(0).Nodes(0).BringIntoView(True)
                    Else
                        e.NewSelections(0).BringIntoView(True)
                    End If

                    prevNode = e.NewSelections(0)
                Else
                    prevNode = e.NewSelections(0).Parent
                End If
            End If
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub
End Class
